Unit ERROR;

interface

function MsgError(num : byte) : string;

implementation

type  StrError = string[40];
const NOERROR  = 'PAS D''ERREUR';
      INDEFERROR = 'ERREUR INDEFINI';
      LongDosError = 18;
      DosError : array[1..LongDosError] of StrError =
               (
                'APPEL DE FONCTION INVALIDE',
                'FICHIER INTROUVABLE',
                'CHEMIN D''ACCES INTROUVABLE',
                'TROP DE FICHIERS OUVERTS SIMULTANEMENT',
                'ACCES AU FICHIER INTERDIT',
                'IDENTIFICATEUR DE FICHIER INVALIDE',
                'ARENA DETRUITS',
                'ESPACE MEMOIRE INSUFFISANT',
                'BLOCK INVALIDE',
                'PAS D''ENVIRONNEMENT',
                'PAS DE FORMAT',
                'CODE D''ACCES FICHIER INVALIDE',
                'DONNEES INVALIDES',
                'NON DEFINI',
                'NUMERO D''UNITE DE DISQUE INVALIDE',
                'NE PEUT SUPPRIMER LE REPERTOIRE COURANT',
                'NE PEUT RENOMMER DE DISQUE A DISQUE',
                'PLUS D''ESPACE POUR LES FICHIERS'
                    );
      LongIOError = 7;
      IOError : array[1..LongIOError] of StrError =
              (
               'ERREUR DISQUE EN LECTURE',
               'ERREUR DISQUE EN ECRITURE',
               'VARIABLE NON ASSOCIEE A UN FICHIER',
               'FICHIER NON OUVERT',
               'FICHIER NON OUVERT EN LECTURE',
               'FICHIER NON OUVERT EN ECRITURE',
               'FORMAT NUMERIQUE INVALIDE'
                  );
      LongCritError = 13;
      CritError : array[1..LongCritError] of StrError =
                (
                 'UNITE DE DISQUE PROTEGE EN ECRITURE',
                 'DISQUE NON RECONNU PAR LE SYSTEME',
                 'UNITE DE DISQUE NON PRETE',
                 'COMMANDE INCONNUE',
                 'ERREUR D''INTEGRITE DES DONNEES LUES',
                 'STRUCTURE COMMUNICATION-DISQUE ERRONEE',
                 'INDISPOSITION DES TETES DU DISQUE',
                 'TYPE DE SUPPORT MAGNETIQUE INCONNU',
                 'SECTEUR NON TROUVE',
                 'ERREUR IMPRIMANTE: FIN DE PAPIER',
                 'ERREUR D''ECRITURE SUR PERIPHERIQUE',
                 'ERREUR DE LECTURE SUR PERIPHERIQUE',
                 'ERREUR LIEE AU MATERIEL'
                     );

function MsgError(num : byte) : string;
var NumTxt : string;
begin
  Str(num,NumTxt);
  NumTxt := ' ('+NumTxt+')';
  if num<=99 then
    begin (* Error DOS *)
      if num=0 then MsgError := NOERROR
      else
        if num>LongDosError then MsgError := INDEFERROR+NumTxt
        else MsgError := DosError[num];
    end
  else
    if num<=149 then
      begin (* Error IO *)
        Dec(num,99);
        if num>LongIOError then MsgError := INDEFERROR+NumTxt
        else MsgError := IOError[num];
      end
    else
      begin (* Error Crit *)
        Dec(num,149);
        if num>LongCritError then MsgError := INDEFERROR+NumTxt
        else MsgError := CritError[num];
      end;
end;

end.