        IDEAL
        %TITLE "SERKIT.ASM  pour SERTOOLS.PAS"
        P8086
        PNO87
        MODEL TPASCAL

        DATASEG

        EXTRN  InSeg    : WORD
        EXTRN  InWrite  : WORD
        EXTRN  InRead   : WORD
        EXTRN  InNb     : WORD
        EXTRN  InLg     : WORD

        EXTRN  OutSeg   : WORD
        EXTRN  OutWrite : WORD
        EXTRN  OutRead  : WORD
        EXTRN  OutNb    : WORD
        EXTRN  OutLg    : WORD

        EXTRN  Chainage : BYTE

        EXTRN  StLine   : BYTE
        EXTRN  StModem  : BYTE

        EXTRN  IT_ID    : WORD

        EXTRN  IOPUT    : WORD

        EXTRN  LN_STAT  : WORD
        EXTRN  MD_STAT  : WORD

        CODESEG

TRUE	EQU  1
FALSE	EQU  0

CIT	EQU  020h
VALIDE_IT EQU  020h

ITMOD	EQU  000h
ITSEND	EQU  002h
ITREC	EQU  004h
ITERR	EQU  006h

        ;
        ; *** debut du controle des IT de communication ***
        ;
LABEL   it      FAR
        PUBLIC it
        ; gere les com IN/OUT
        pushf
        push ax
        push bx
        push dx
        push ds
        push es

        mov  ax, @data
        mov  ds, ax

        mov  dx, [IT_ID]
        in   al, dx
icBOUCLE:
        and  al, 006h
        cmp  al, ITREC
        je   icITREC
        cmp  al, ITSEND
        je   icITSEND
        cmp  al, ITERR
        je   icITERR
        cmp  al, ITMOD
        je   icITMOD
        jmp  SHORT icNEXT
icITMOD:
        ; signal modem
        mov  dx, [MD_STAT]
        in   al, dx
        mov  [StModem], al
        jmp  SHORT icNEXT
icITERR:
	; signal d'erreur sur la ligne
        mov  dx, [LN_STAT]
        in   al, dx
        mov  [StLine], al
        jmp  SHORT icNEXT
icITSEND:
        ; port d'emission libre
        cmp  [OutNb], 0
        jne  icemet		; buffer non vide
        ; buffer vide
        mov  [Chainage], FALSE 	; le chainage des sortie
        jmp  SHORT icNEXT	; n'est plus soutenue
icemet:
        mov  [Chainage], TRUE
        mov  bx, [OutSeg]
        mov  es, bx
        mov  bx, [OutRead]
        mov  al, [es:bx]	; prend car du buffer
        mov  dx, [IOPUT]
        out  dx, al		; envoi
        inc  bx
        cmp  bx, [OutLg]
        jb   ic_outlo
        xor  bx, bx
ic_outlo:
        mov  [OutRead], bx
        dec  [OutNb]             ; -1 car restant a emettre
        jmp  SHORT icNEXT
icITREC:
        ; reception d'un car
        mov  dx, [IOPUT]
        in   al, dx             ; saisir le car recu
        mov  bx, [InNb]
        cmp  bx, [InLg]
        jae  icNEXT             ; pas de place!
        mov  bx, [InSeg]
        mov  es, bx
        mov  bx, [InWrite]
        mov  [es:bx], al        ; sauve le car recu dans le buffer
        inc  bx
        cmp  bx, [InLg]
        jb   ic_SET2
        xor  bx, bx
ic_SET2:
        mov  [InWrite], bx
        inc  [InNb]
icNEXT:
        mov  dx, [IT_ID]
        in   al, dx
        test al, 001h
        jnz  icFIN
        jmp  icBOUCLE		; autre(s) signaux en attente
icFIN:
        mov  dx, VALIDE_IT
        mov  al, CIT
        out  dx, al

        pop  es
        pop  ds
        pop  dx
        pop  bx
        pop  ax
        popf

        iret
        ;
        ; *** fin du controle des IT de communication ***
        ;


        ;
        ; *** CharIn ***
        ;
LABEL   CharIn FAR
        PUBLIC CharIn
        ; (non PROC afin d'eviter les sauvegardes de registres inutile! )
        cmp  [InLg], 0
        je   crLA       ; les interruption ne gere pas ca
        cmp  [InNb], 0
        je   crpasdecar
        mov  al, TRUE   ; caractere en attente!
        retf
crpasdecar:
        mov  al, FALSE  ; c vide!
        retf
crLA:
        mov  dx, [LN_STAT]
        in   al, dx
        and  al, 001h   ; 0 si pas de car, 1 si car
        retf
        ;
        ; *** fin de CharIn ***
        ;

        ;
        ; *** OutReady ***
        ;
LABEL   OutReady NEAR
        PUBLIC OutReady

        ; Attention c NEAR! et c'est public!
        mov  dx, [LN_STAT]
        in   al, dx
        and  al, 020h
        jz   poFIN
        mov  al, TRUE
poFIN:  retn
        ;
        ; *** fin de OutReady ***
        ;

        ;
        ; *** OutEmpty ***
        ;
LABEL   OutEmpty FAR
        PUBLIC OutEmpty

        cmp  [OutLg], 0
        je   oeOUTREADY   ; pas d'interruption en sortie
        cmp  [OutNb], 0
        je   oeOUTREADY
        mov  al, FALSE
        retf
oeOUTREADY:
        call OutReady
        retf
        ;
        ; *** fin de OutEmpty
        ;

        ;
        ; *** GetCom ***
        ;
LABEL   GetCom FAR
        PUBLIC GetCom
gcCharIn:
        call Charin
        cmp  al, 0
        je   gcCharIn    ; attend l'arrive d'un car

        cmp  [InLg], 0
        je   gcNOINT     ; pas d'interrupt

        mov  ax, [InSeg]
        mov  es, ax
        mov  bx, [InRead]
        mov  al, [es:bx] ; saisie car
        inc  bx
        cmp  bx, [InLg]
        jb   gcINF
        xor  bx, bx
gcINF:
        mov  [InRead], bx
        dec  [InNb]
        retf
gcNOINT:
        mov  dx, [IOPUT]
        in   al, dx
        retf
        ;
        ; *** fin de GetCom ***
        ;

PROC    PutCom FAR Car : BYTE
        PUBLIC PutCom

        ; PutCom(Car : char )

        cmp  [OutLg], 0
        je   @@NOINT        ; pas d'interruption gerante

        mov  ax, [OutLg]
@@LA:
        cmp  ax, [OutNb]
        jbe  @@LA           ; buffer plein donc on boucle

        mov  bx, [OutSeg]
        mov  es, bx
        mov  cl, [Car]      ; caractre a emettre
        mov  bx, [OutWrite]
        mov  [es:bx], cl
        inc  bx
        cmp  bx, [OutLg]
        jb   @@ICI
        xor  bx, bx
@@ICI:
        mov  [OutWrite], bx
        inc  [OutNb]

        cmp  [Chainage], FALSE
        jne  @@FIN        ; chainage en cours donc on laisse...
        ; chainage non actif, il faut le lancer

        cmp  [OutNb], 0
        je   @@FIN        ; buffer vide donc rien a chainer...

        mov  ax, [OutRead]
        mov  bx, ax
        inc  ax
        cmp  ax, [OutLg]
        jb   @@BALANCE
        xor  ax, ax
@@BALANCE:
        mov  [OutRead], ax
        mov  al, [es:bx]     ; premier car du buffer
        mov  [Chainage], TRUE
        dec  [OutNb]
        mov  dx, [IOPUT]
        out  dx, al
        jmp  SHORT @@FIN

@@NOINT:
        call OutReady
        cmp  al, 0
        je   @@NOINT         ; attend le port libre
        mov  dx, [IOPUT]
        mov  al, [Car]       ; prend le car
        out  dx, al

@@FIN:
        ret

ENDP    PutCom

        END
