        IDEAL
        %TITLE "VIDEO2KIT.ASM  pour VIDEO2.PAS"
        P8086
        PNO87
        MODEL TPASCAL

        DATASEG

        EXTRN      ScrLg   : BYTE    ; 80 colonnes
        EXTRN      ScrHt   : BYTE    ; 25 lignes
        EXTRN      ScrSnow : BYTE    ; 0 pas de neige
        EXTRN      ScrAdr  : DWORD   ; Adresse ecran


        CODESEG

VIDEOSTAT    EQU   03DAh

        ;
        ; *** Si_HorsEcran ***
        ;
MACRO   Si_HorsEcran X,Y,SautDehors
        ; x et y dans AX
        ; CF=0 x et y dans l'ecran   CF=1 hors ecran
        mov  al, X
        cmp  al, [ScrLg]
        jae  SautDehors
        mov  al, Y
        cmp  al, [ScrHt]
        jae  SautDehors
ENDM
        ;
        ; *** fin de Si_HorsEcran ***
        ;

        ;
        ; *** CalcXY ***
        ;
MACRO   OfsEcran X,Y
        ; retourne en AX l'offset ecran de X,Y
        mov  al, Y
        mul  [ScrLg]
        add  al, X
        adc  ah, 0
        shl  ax, 1
ENDM
        ;
        ; *** fin de CalcXY ***
        ;

MACRO   NeigeControl
        LOCAL CF0,CF1
        ; effectue l'attente jusqu'a plus de risque de neige...
        ; dx doit contenire VIDEOSTAT !!!
CF1:
        in   al, dx
        rcr  al, 1
        jb   CF1
CF0:
        in   al, dx
        rcr  al, 1
        jnb  CF0
ENDM

PROC    WrtDt  FAR Car : BYTE, X : BYTE, Y : BYTE, Attrib : BYTE
        PUBLIC WrtDt

        ; WrtDt(car,x,y, attrib )

        Si_HorsEcran [X] [Y] @@FIN
        OfsEcran [X] [Y]   ; calcule l'offset ecran (mis dans AX)
        les  bx, [ScrAdr]
        add  bx, ax
        mov  cl, [Car]     ; car
        mov  ch, [Attrib]  ; attrib
        cmp  [ScrSnow], 0
        je   @@TOSCR       ; pas de neige
        mov  dx, VIDEOSTAT
        NeigeControl
@@TOSCR:
        mov  [es:bx], cx
@@FIN:
        ret

ENDP    WrtDt


PROC    WrtScr FAR  Texte:DWORD, X:BYTE, Y:BYTE, Attrib:BYTE
        PUBLIC WrtScr

        ; WrtDt(texte,x,y,attrib)

        push ds

        Si_HorsEcran [X] [Y] @@FIN     ; hors de l'ecran!
        mov  cl, [Scrlg]
        sub  cl, [X]       ; nombre de car a envoye maximun!!
                           ; dans cl
        OfsEcran [X] [Y]
        les  di, [ScrAdr]  ; destination
        add  di, ax
        mov  ah, [Attrib]  ; range attrib a diffuser
        mov  bl, [ScrSnow] ; on fait cela car
                                        ; DS devient une fausse base!
        cld
        lds  si, [Texte]   ; pointeur texte
        lodsb              ; prend longueur de chaine
        mov  bh, al        ; BL=longueur de chaine
        mov  dx, VIDEOSTAT

@@BOUCLE:
        cmp  bh, 0         ; reste rien a lire?
        je   @@FIN         ; oui
        dec  bh
        lodsb
@@SUIV:
        cmp  bl, 0         ; neige?
        je   @@CONT        ; non!
        mov  ch, al        ; sauve
        NeigeControl
        mov  al, ch        ; restore
@@CONT:
        stosw              ; ax->ecran
        dec  cl
        cmp  cl, 0
        jne  @@BOUCLE

@@FIN:  pop     ds
        ret
ENDP    WrtScr

PROC    FromScr  FAR Dest:DWORD, X:BYTE, Y:BYTE, Lg:BYTE
        PUBLIC FromScr

        ; FromScr(dest,x,y,lg)

        push ds

        Si_HorsEcran [X] [Y] @@FIN     ; hors ecran

        mov  cl, [Lg]      ; lg
        xor  ch, ch        ; cx = lg

        mov  bl, [X]
        xor  bh, bh        ; bx = x
        add  bx, cx        ; lg+x ->bx
        mov  dl, [ScrLg]
        mov  dh, dh        ; dx = ScrLg
        cmp  bx, dx
        jbe  @@OK
        ; une correction de lg est necessaire
        mov  cl, [X]
        xor  ch, ch
        sub  dx, cx
        mov  cx, dx
@@OK:
        jcxz @@FIN
        mov  bl, [ScrSnow] ; l'etat neige en BL
        les  di, [Dest]    ; adr texte destination
        OfsEcran [X] [Y]
        lds  si, [ScrAdr]
        add  si, ax        ; DS:SI designe l'ecran

        mov  dx, VIDEOSTAT
        cld
@@SUIV:
        ; saisie d'un car+attrib de l'ecran
        cmp  bl, 0           ; neige?
        je   @@FROMSCR ; non!
        NeigeControl
@@FROMSCR:
        lodsw
        stosw
        loop @@SUIV
@@FIN:
        pop     ds
        ret
ENDP    FromScr

PROC    ToScr  FAR Source:DWORD, X:BYTE, Y:BYTE, Lg:BYTE
        PUBLIC ToScr

        ; ToScr(source,x,y,lg)

        push ds

        Si_HorsEcran [X] [Y] @@FIN
        OfsEcran [X] [Y]
        les  di, [ScrAdr]
        add  di, ax

        mov  cl, [Lg]      ; lg
        xor  ch, ch        ; cx = lg

        mov  al, [X]       ; x
        mov  bl, al
        xor  bh, bh        ; bx = x
        add  bx, cx        ; lg+x ->bx
        mov  dl, [ScrLg]
        mov  dh, dh        ; dx = ScrLg
        cmp  bx, dx
        jbe  @@OK
        ; une correction de lg est necessaire
        mov  cl, al
        xor  ch, ch
        sub  dx, cx
        mov  cx, dx
@@OK:
        jcxz @@FIN
        mov  bl, [ScrSnow] ; neige en BL

        lds  si, [Source]  ; pointe sur le texte DS FAUX!
        mov  dx, VIDEOSTAT
        cld
@@SUIV:
        ; saisie d'un car+attrib du texte
        lodsw
        cmp  bl, 0
        je   @@TOSCR ; pas de neige
        mov  bh, al        ; sauve AL
        NeigeControl
        mov al, bh        ; restore AL
@@TOSCR:
        stosw
        loop @@SUIV
@@FIN:
        pop  ds
        ret

ENDP    ToScr


        END
